<?php
namespace SM\Service;

use SM\Factory\Sm00004110TipoRescisaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00004110TipoRescisaoService {

    protected $tipoRescisaoFactory;
    protected $environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, Sm00004110TipoRescisaoFactory $tipoRescisaoFactory, Environment $environment, NewCode $newCode) {
        $this->connection          = $entityManager->getConnection();
        $this->tipoRescisaoFactory = $tipoRescisaoFactory;
        $this->environment         = $environment;
        $this->newCode             = $newCode;
    }

    public function getTipoRescisao() {
        return $this->tipoRescisaoFactory->getTipoRescisao();
    }

    public function getModeloDocumento() {
        return $this->tipoRescisaoFactory->getModeloDocumento();
    }

    public function editarTipoRescisao($params){
        $this->connection->beginTransaction();
       
        try {
            $nrorg = $this->environment->getNrorg();
            $operador = $this->environment->getCdOperador();
            
            foreach ($params["DRG"] as $row ){

                if($row["NRTIPORESCISAO"] != 0 ){
                    $parametros = array (
                        "NRTIPORESCISAO" => $row["NRTIPORESCISAO"],
                        "DSTIPORESCISAO" => $row['DSTIPORESCISAO'],
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERULTATU"   => $operador,
                        "NRSEQMODDOCFCT" => isset($row["NRSEQMODDOCFCT"]) ? $row["NRSEQMODDOCFCT"] : "",
                        "IDPERMITEDOCX"  => $row['IDPERMITEDOCX']
                    );
                    
                    $this->tipoRescisaoFactory->editarTipoRescisao($parametros);
                } else {
                    $nrtiporescisao = $this->newCode->getCodeByTableName("FCT_TIPORESCISAO", $nrorg, 1, 10, true);
                    $parametros = array (
                        "NRTIPORESCISAO" => $nrtiporescisao,
                        "DSTIPORESCISAO" => $row['DSTIPORESCISAO'],
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "CDOPERINCLUSAO" => $operador,
                        "NRSEQMODDOCFCT" => isset($row["NRSEQMODDOCFCT"]) ? $row["NRSEQMODDOCFCT"] : "",
                        "IDPERMITEDOCX"  => $row['IDPERMITEDOCX']
                    );
                    
                    $this->tipoRescisaoFactory->inserirMotivos($parametros);
                }                    
            }
            $this->connection->commit();
        }catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function excluirTipoRescisao($parametro) {
        $param = implode(',' , $parametro["NRS"]);
        $this->tipoRescisaoFactory->excluirTipoRescisao($param);
    }
}
?>