<?php

namespace SM\Service;

use SM\Factory\Sm00057002ConfiguracaoRegionalMoedaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00057002ConfiguracaoRegionalMoedaService
{
    protected $connection;
    protected $Sm00057002ConfiguracaoRegionalMoedaFactory;
    protected $environment;
    protected $newCode;

    public function __construct(Sm00057002ConfiguracaoRegionalMoedaFactory $Sm00057002ConfiguracaoRegionalMoedaFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager)
    {
        $this->Sm00057002ConfiguracaoRegionalMoedaFactory = $Sm00057002ConfiguracaoRegionalMoedaFactory;
        $this->environment               = $environment;
        $this->newCode                   = $newCode;
        $this->connection                = $entityManager->getConnection();
    }

    public function getConfiguracaoRegionalMoeda()
    {
        return $this->Sm00057002ConfiguracaoRegionalMoedaFactory->getConfiguracaoRegionalMoeda();
    }

    public function inserirConfiguracaoRegionalMoeda($parametros)
    {
        $cdoperador = $this->environment->getCdOperador();
        $NRORG = $this->environment->getNrOrg();
        $this->connection->beginTransaction();
        $paramsaux = array(
          "NMMOEDA" => $parametros[0]['NMMOEDA'],
          "NRMOEDA" => $parametros[0]['NRMOEDA']
        );
        $dados = $this->Sm00057002ConfiguracaoRegionalMoedaFactory->validaConfiguracaoRegionalMoeda($paramsaux);
        try {
            foreach ($parametros as $chave => $linha) {
                if ($linha["NRMOEDA"] == 0) {
                    $NRMOEDA  = $this->newCode->getCodeByTableName("FCT_MOEDA", $NRORG, 1, 10, true);
                    if ($dados[0]["VALIDAMOEDA"] > 0) {
                        throw new \Exception("MOEDA JÁ EXISTE!");
                    } 
                    else{
                        $dataParam = array(
                            "NRMOEDA"        => $NRMOEDA,
                            "NMMOEDA"        => $linha["NMMOEDA"],
                            "SIMBOLOMOEDA"   => isset($linha["SIMBOLOMOEDA"]) ? $linha["SIMBOLOMOEDA"] : null,
                            "CDISOMOEDA"     => isset($linha["CDISOMOEDA"]) ? $linha["CDISOMOEDA"] : null,
                            "IDATIVO"        => $linha["IDATIVO"],
                            "NRORG"          => $NRORG,
                            "NRORGINCLUSAO"  => $NRORG,
                            "CDOPERINCLUSAO" => $cdoperador,
                            "IDPADRAO"       => $linha["IDPADRAO"],
                        );
                        $this->Sm00057002ConfiguracaoRegionalMoedaFactory->inserirConfiguracaoRegionalMoeda($dataParam);
                        if ($linha["IDPADRAO"] == "S") {
                            $dataParam = array(
                                "IDPADRAO" => "N",
                                "NRMOEDA"  => $NRMOEDA,
                            );
                            $this->Sm00057002ConfiguracaoRegionalMoedaFactory->atualizarConfiguracaoRegionalIdPadraoMoeda($dataParam);
                        }
                    }  
                } else {
                    if ($dados[0]["VALIDAMOEDA"] > 0) {
                        throw new \Exception("MOEDA JÁ EXISTE!");
                    }
                    else {
                        $dataParam = array(
                            "NMMOEDA"      => $linha["NMMOEDA"],
                            "SIMBOLOMOEDA" => $linha["SIMBOLOMOEDA"],
                            "CDISOMOEDA"   => $linha["CDISOMOEDA"],
                            "IDATIVO"      => $linha["IDATIVO"],
                            "NRORG"        => $NRORG,
                            "NRORGULTATU"  => $NRORG,
                            "CDOPERULTATU" => $cdoperador,
                            "IDPADRAO"     => $linha["IDPADRAO"],
                            "NRMOEDA"      => $linha["NRMOEDA"],
                        );
                        $this->Sm00057002ConfiguracaoRegionalMoedaFactory->atualizarConfiguracaoRegionalMoeda($dataParam);

                        if ($linha["IDPADRAO"] == "S") {
                            $dataParam = array(
                                "IDPADRAO" => "N",
                                "NRMOEDA"  => $linha["NRMOEDA"],
                            );
                            $this->Sm00057002ConfiguracaoRegionalMoedaFactory->atualizarConfiguracaoRegionalIdPadraoMoeda($dataParam);
                        }
                    }
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deletarConfiguracaoRegionalMoeda($parametros)
    {
        $this->connection->beginTransaction();
        try {
            foreach ($parametros as $linha) {
                $dataParam = array("NRMOEDA" => $linha["NRMOEDA"]);
                $this->Sm00057002ConfiguracaoRegionalMoedaFactory->deletarConfiguracaoRegionalMoeda($dataParam);
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
